# coding: utf-8

"""
    Intrinio API

    Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.  # noqa: E501

    OpenAPI spec version: 2.52.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from intrinio_sdk.models.realtime_stock_price_security import RealtimeStockPriceSecurity  # noqa: F401,E501


class RealtimeStockPrice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'last_price': 'float',
        'last_time': 'datetime',
        'last_size': 'float',
        'bid_price': 'float',
        'bid_size': 'float',
        'ask_price': 'float',
        'ask_size': 'float',
        'open_price': 'float',
        'close_price': 'float',
        'high_price': 'float',
        'low_price': 'float',
        'exchange_volume': 'float',
        'market_volume': 'float',
        'updated_on': 'datetime',
        'source': 'str',
        'listing_venue': 'str',
        'sales_conditions': 'str',
        'quote_conditions': 'str',
        'market_center_code': 'str',
        'is_darkpool': 'bool',
        'security': 'RealtimeStockPriceSecurity'
    }

    attribute_map = {
        'last_price': 'last_price',
        'last_time': 'last_time',
        'last_size': 'last_size',
        'bid_price': 'bid_price',
        'bid_size': 'bid_size',
        'ask_price': 'ask_price',
        'ask_size': 'ask_size',
        'open_price': 'open_price',
        'close_price': 'close_price',
        'high_price': 'high_price',
        'low_price': 'low_price',
        'exchange_volume': 'exchange_volume',
        'market_volume': 'market_volume',
        'updated_on': 'updated_on',
        'source': 'source',
        'listing_venue': 'listing_venue',
        'sales_conditions': 'sales_conditions',
        'quote_conditions': 'quote_conditions',
        'market_center_code': 'market_center_code',
        'is_darkpool': 'is_darkpool',
        'security': 'security'
    }

    def __init__(self, last_price=None, last_time=None, last_size=None, bid_price=None, bid_size=None, ask_price=None, ask_size=None, open_price=None, close_price=None, high_price=None, low_price=None, exchange_volume=None, market_volume=None, updated_on=None, source=None, listing_venue=None, sales_conditions=None, quote_conditions=None, market_center_code=None, is_darkpool=None, security=None):  # noqa: E501
        """RealtimeStockPrice - a model defined in Swagger"""  # noqa: E501

        self._last_price = None
        self._last_time = None
        self._last_size = None
        self._bid_price = None
        self._bid_size = None
        self._ask_price = None
        self._ask_size = None
        self._open_price = None
        self._close_price = None
        self._high_price = None
        self._low_price = None
        self._exchange_volume = None
        self._market_volume = None
        self._updated_on = None
        self._source = None
        self._listing_venue = None
        self._sales_conditions = None
        self._quote_conditions = None
        self._market_center_code = None
        self._is_darkpool = None
        self._security = None
        self.discriminator = None

        if last_price is not None:
            self.last_price = last_price
        if last_time is not None:
            self.last_time = last_time
        if last_size is not None:
            self.last_size = last_size
        if bid_price is not None:
            self.bid_price = bid_price
        if bid_size is not None:
            self.bid_size = bid_size
        if ask_price is not None:
            self.ask_price = ask_price
        if ask_size is not None:
            self.ask_size = ask_size
        if open_price is not None:
            self.open_price = open_price
        if close_price is not None:
            self.close_price = close_price
        if high_price is not None:
            self.high_price = high_price
        if low_price is not None:
            self.low_price = low_price
        if exchange_volume is not None:
            self.exchange_volume = exchange_volume
        if market_volume is not None:
            self.market_volume = market_volume
        if updated_on is not None:
            self.updated_on = updated_on
        if source is not None:
            self.source = source
        if listing_venue is not None:
            self.listing_venue = listing_venue
        if sales_conditions is not None:
            self.sales_conditions = sales_conditions
        if quote_conditions is not None:
            self.quote_conditions = quote_conditions
        if market_center_code is not None:
            self.market_center_code = market_center_code
        if is_darkpool is not None:
            self.is_darkpool = is_darkpool
        if security is not None:
            self.security = security

    @property
    def last_price(self):
        """Gets the last_price of this RealtimeStockPrice.  # noqa: E501

        The price of the last trade.  # noqa: E501

        :return: The last_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._last_price
        
    @property
    def last_price_dict(self):
        """Gets the last_price of this RealtimeStockPrice.  # noqa: E501

        The price of the last trade. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The last_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.last_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'last_price': value }

        
        return result
        

    @last_price.setter
    def last_price(self, last_price):
        """Sets the last_price of this RealtimeStockPrice.

        The price of the last trade.  # noqa: E501

        :param last_price: The last_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._last_price = last_price

    @property
    def last_time(self):
        """Gets the last_time of this RealtimeStockPrice.  # noqa: E501

        The date and time when the last trade occurred.  # noqa: E501

        :return: The last_time of this RealtimeStockPrice.  # noqa: E501
        :rtype: datetime
        """
        return self._last_time
        
    @property
    def last_time_dict(self):
        """Gets the last_time of this RealtimeStockPrice.  # noqa: E501

        The date and time when the last trade occurred. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The last_time of this RealtimeStockPrice.  # noqa: E501
        :rtype: datetime
        """

        result = None

        value = self.last_time
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'last_time': value }

        
        return result
        

    @last_time.setter
    def last_time(self, last_time):
        """Sets the last_time of this RealtimeStockPrice.

        The date and time when the last trade occurred.  # noqa: E501

        :param last_time: The last_time of this RealtimeStockPrice.  # noqa: E501
        :type: datetime
        """

        self._last_time = last_time

    @property
    def last_size(self):
        """Gets the last_size of this RealtimeStockPrice.  # noqa: E501

        The size of the last trade.  # noqa: E501

        :return: The last_size of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._last_size
        
    @property
    def last_size_dict(self):
        """Gets the last_size of this RealtimeStockPrice.  # noqa: E501

        The size of the last trade. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The last_size of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.last_size
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'last_size': value }

        
        return result
        

    @last_size.setter
    def last_size(self, last_size):
        """Sets the last_size of this RealtimeStockPrice.

        The size of the last trade.  # noqa: E501

        :param last_size: The last_size of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._last_size = last_size

    @property
    def bid_price(self):
        """Gets the bid_price of this RealtimeStockPrice.  # noqa: E501

        The price of the top bid order.  # noqa: E501

        :return: The bid_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._bid_price
        
    @property
    def bid_price_dict(self):
        """Gets the bid_price of this RealtimeStockPrice.  # noqa: E501

        The price of the top bid order. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The bid_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.bid_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'bid_price': value }

        
        return result
        

    @bid_price.setter
    def bid_price(self, bid_price):
        """Sets the bid_price of this RealtimeStockPrice.

        The price of the top bid order.  # noqa: E501

        :param bid_price: The bid_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._bid_price = bid_price

    @property
    def bid_size(self):
        """Gets the bid_size of this RealtimeStockPrice.  # noqa: E501

        The size of the top bid order.  # noqa: E501

        :return: The bid_size of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._bid_size
        
    @property
    def bid_size_dict(self):
        """Gets the bid_size of this RealtimeStockPrice.  # noqa: E501

        The size of the top bid order. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The bid_size of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.bid_size
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'bid_size': value }

        
        return result
        

    @bid_size.setter
    def bid_size(self, bid_size):
        """Sets the bid_size of this RealtimeStockPrice.

        The size of the top bid order.  # noqa: E501

        :param bid_size: The bid_size of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._bid_size = bid_size

    @property
    def ask_price(self):
        """Gets the ask_price of this RealtimeStockPrice.  # noqa: E501

        The price of the top ask order.  # noqa: E501

        :return: The ask_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._ask_price
        
    @property
    def ask_price_dict(self):
        """Gets the ask_price of this RealtimeStockPrice.  # noqa: E501

        The price of the top ask order. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The ask_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.ask_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'ask_price': value }

        
        return result
        

    @ask_price.setter
    def ask_price(self, ask_price):
        """Sets the ask_price of this RealtimeStockPrice.

        The price of the top ask order.  # noqa: E501

        :param ask_price: The ask_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._ask_price = ask_price

    @property
    def ask_size(self):
        """Gets the ask_size of this RealtimeStockPrice.  # noqa: E501

        The size of the top ask order.  # noqa: E501

        :return: The ask_size of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._ask_size
        
    @property
    def ask_size_dict(self):
        """Gets the ask_size of this RealtimeStockPrice.  # noqa: E501

        The size of the top ask order. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The ask_size of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.ask_size
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'ask_size': value }

        
        return result
        

    @ask_size.setter
    def ask_size(self, ask_size):
        """Sets the ask_size of this RealtimeStockPrice.

        The size of the top ask order.  # noqa: E501

        :param ask_size: The ask_size of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._ask_size = ask_size

    @property
    def open_price(self):
        """Gets the open_price of this RealtimeStockPrice.  # noqa: E501

        The price at the open of the trading day.  # noqa: E501

        :return: The open_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._open_price
        
    @property
    def open_price_dict(self):
        """Gets the open_price of this RealtimeStockPrice.  # noqa: E501

        The price at the open of the trading day. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The open_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.open_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'open_price': value }

        
        return result
        

    @open_price.setter
    def open_price(self, open_price):
        """Sets the open_price of this RealtimeStockPrice.

        The price at the open of the trading day.  # noqa: E501

        :param open_price: The open_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._open_price = open_price

    @property
    def close_price(self):
        """Gets the close_price of this RealtimeStockPrice.  # noqa: E501

        The price at the close of the trading day. (IEX only)  # noqa: E501

        :return: The close_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._close_price
        
    @property
    def close_price_dict(self):
        """Gets the close_price of this RealtimeStockPrice.  # noqa: E501

        The price at the close of the trading day. (IEX only) as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The close_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.close_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'close_price': value }

        
        return result
        

    @close_price.setter
    def close_price(self, close_price):
        """Sets the close_price of this RealtimeStockPrice.

        The price at the close of the trading day. (IEX only)  # noqa: E501

        :param close_price: The close_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._close_price = close_price

    @property
    def high_price(self):
        """Gets the high_price of this RealtimeStockPrice.  # noqa: E501

        The high price for the trading day.  # noqa: E501

        :return: The high_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._high_price
        
    @property
    def high_price_dict(self):
        """Gets the high_price of this RealtimeStockPrice.  # noqa: E501

        The high price for the trading day. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The high_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.high_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'high_price': value }

        
        return result
        

    @high_price.setter
    def high_price(self, high_price):
        """Sets the high_price of this RealtimeStockPrice.

        The high price for the trading day.  # noqa: E501

        :param high_price: The high_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._high_price = high_price

    @property
    def low_price(self):
        """Gets the low_price of this RealtimeStockPrice.  # noqa: E501

        The low price for the trading day.  # noqa: E501

        :return: The low_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._low_price
        
    @property
    def low_price_dict(self):
        """Gets the low_price of this RealtimeStockPrice.  # noqa: E501

        The low price for the trading day. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The low_price of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.low_price
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'low_price': value }

        
        return result
        

    @low_price.setter
    def low_price(self, low_price):
        """Sets the low_price of this RealtimeStockPrice.

        The low price for the trading day.  # noqa: E501

        :param low_price: The low_price of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._low_price = low_price

    @property
    def exchange_volume(self):
        """Gets the exchange_volume of this RealtimeStockPrice.  # noqa: E501

        The number of shares exchanged during the trading day on the exchange.  # noqa: E501

        :return: The exchange_volume of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._exchange_volume
        
    @property
    def exchange_volume_dict(self):
        """Gets the exchange_volume of this RealtimeStockPrice.  # noqa: E501

        The number of shares exchanged during the trading day on the exchange. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The exchange_volume of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.exchange_volume
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'exchange_volume': value }

        
        return result
        

    @exchange_volume.setter
    def exchange_volume(self, exchange_volume):
        """Sets the exchange_volume of this RealtimeStockPrice.

        The number of shares exchanged during the trading day on the exchange.  # noqa: E501

        :param exchange_volume: The exchange_volume of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._exchange_volume = exchange_volume

    @property
    def market_volume(self):
        """Gets the market_volume of this RealtimeStockPrice.  # noqa: E501

        The number of shares exchanged during the trading day for the whole market.  # noqa: E501

        :return: The market_volume of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """
        return self._market_volume
        
    @property
    def market_volume_dict(self):
        """Gets the market_volume of this RealtimeStockPrice.  # noqa: E501

        The number of shares exchanged during the trading day for the whole market. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The market_volume of this RealtimeStockPrice.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.market_volume
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'market_volume': value }

        
        return result
        

    @market_volume.setter
    def market_volume(self, market_volume):
        """Sets the market_volume of this RealtimeStockPrice.

        The number of shares exchanged during the trading day for the whole market.  # noqa: E501

        :param market_volume: The market_volume of this RealtimeStockPrice.  # noqa: E501
        :type: float
        """

        self._market_volume = market_volume

    @property
    def updated_on(self):
        """Gets the updated_on of this RealtimeStockPrice.  # noqa: E501

        The date and time when the data was last updated.  # noqa: E501

        :return: The updated_on of this RealtimeStockPrice.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_on
        
    @property
    def updated_on_dict(self):
        """Gets the updated_on of this RealtimeStockPrice.  # noqa: E501

        The date and time when the data was last updated. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The updated_on of this RealtimeStockPrice.  # noqa: E501
        :rtype: datetime
        """

        result = None

        value = self.updated_on
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'updated_on': value }

        
        return result
        

    @updated_on.setter
    def updated_on(self, updated_on):
        """Sets the updated_on of this RealtimeStockPrice.

        The date and time when the data was last updated.  # noqa: E501

        :param updated_on: The updated_on of this RealtimeStockPrice.  # noqa: E501
        :type: datetime
        """

        self._updated_on = updated_on

    @property
    def source(self):
        """Gets the source of this RealtimeStockPrice.  # noqa: E501

        The source of the data.  # noqa: E501

        :return: The source of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """
        return self._source
        
    @property
    def source_dict(self):
        """Gets the source of this RealtimeStockPrice.  # noqa: E501

        The source of the data. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The source of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.source
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'source': value }

        
        return result
        

    @source.setter
    def source(self, source):
        """Sets the source of this RealtimeStockPrice.

        The source of the data.  # noqa: E501

        :param source: The source of this RealtimeStockPrice.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def listing_venue(self):
        """Gets the listing_venue of this RealtimeStockPrice.  # noqa: E501

        The listing venue where the trade took place. Available only where source is SIP. Listing Venue Modifiers include: Q – Nasdaq | N – NYSE | A – NYSE American | P – NYSE Arca | u – Other OTC Markets | V – Investors Exchange LLC   # noqa: E501

        :return: The listing_venue of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """
        return self._listing_venue
        
    @property
    def listing_venue_dict(self):
        """Gets the listing_venue of this RealtimeStockPrice.  # noqa: E501

        The listing venue where the trade took place. Available only where source is SIP. Listing Venue Modifiers include: Q – Nasdaq | N – NYSE | A – NYSE American | P – NYSE Arca | u – Other OTC Markets | V – Investors Exchange LLC  as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The listing_venue of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.listing_venue
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'listing_venue': value }

        
        return result
        

    @listing_venue.setter
    def listing_venue(self, listing_venue):
        """Sets the listing_venue of this RealtimeStockPrice.

        The listing venue where the trade took place. Available only where source is SIP. Listing Venue Modifiers include: Q – Nasdaq | N – NYSE | A – NYSE American | P – NYSE Arca | u – Other OTC Markets | V – Investors Exchange LLC   # noqa: E501

        :param listing_venue: The listing_venue of this RealtimeStockPrice.  # noqa: E501
        :type: str
        """

        self._listing_venue = listing_venue

    @property
    def sales_conditions(self):
        """Gets the sales_conditions of this RealtimeStockPrice.  # noqa: E501

        When applicable, indicates any sales condition modifiers associated with the trade. Sales Condition Modifers include: @ – Regular Sale | A – Acquisition | B – Bunched Trade | C – Cash Sale | D – Distribution | E – Placeholder | F – Intermarket Sweep | G – Bunched Sold Trade  | H – Priced Variation Trade | I – Odd Lot Trade | K – Rule 155 Trade (AMEX) | L – Sold Last | M – Market Center Official Close | N – Next Day | O – Opening Prints  | P – Prior Reference Price | Q – Market Center Official Open | R – Seller | S – Split Trade | T – Form T | U – Extended Trading Hours (Sold Out of Sequence)  | V – Contingent Trade | W – Average Price Trade | X – Cross/Periodic Auction Trade | Y – Yellow Flag Regular Trade | Z – Sold (Out of Sequence)  | 1 – Stopped Stock (Regular Trade) | 4 – Derivatively Priced | 5 – Re-Opening Prints | 6 – Closing Prints | 7 – Qualified Contingent Trade (QCT)  | 8 – Placeholder for 611 Exempt | 9 – Corrected Consolidated Close (Per Listing Market)   # noqa: E501

        :return: The sales_conditions of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """
        return self._sales_conditions
        
    @property
    def sales_conditions_dict(self):
        """Gets the sales_conditions of this RealtimeStockPrice.  # noqa: E501

        When applicable, indicates any sales condition modifiers associated with the trade. Sales Condition Modifers include: @ – Regular Sale | A – Acquisition | B – Bunched Trade | C – Cash Sale | D – Distribution | E – Placeholder | F – Intermarket Sweep | G – Bunched Sold Trade  | H – Priced Variation Trade | I – Odd Lot Trade | K – Rule 155 Trade (AMEX) | L – Sold Last | M – Market Center Official Close | N – Next Day | O – Opening Prints  | P – Prior Reference Price | Q – Market Center Official Open | R – Seller | S – Split Trade | T – Form T | U – Extended Trading Hours (Sold Out of Sequence)  | V – Contingent Trade | W – Average Price Trade | X – Cross/Periodic Auction Trade | Y – Yellow Flag Regular Trade | Z – Sold (Out of Sequence)  | 1 – Stopped Stock (Regular Trade) | 4 – Derivatively Priced | 5 – Re-Opening Prints | 6 – Closing Prints | 7 – Qualified Contingent Trade (QCT)  | 8 – Placeholder for 611 Exempt | 9 – Corrected Consolidated Close (Per Listing Market)  as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The sales_conditions of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.sales_conditions
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'sales_conditions': value }

        
        return result
        

    @sales_conditions.setter
    def sales_conditions(self, sales_conditions):
        """Sets the sales_conditions of this RealtimeStockPrice.

        When applicable, indicates any sales condition modifiers associated with the trade. Sales Condition Modifers include: @ – Regular Sale | A – Acquisition | B – Bunched Trade | C – Cash Sale | D – Distribution | E – Placeholder | F – Intermarket Sweep | G – Bunched Sold Trade  | H – Priced Variation Trade | I – Odd Lot Trade | K – Rule 155 Trade (AMEX) | L – Sold Last | M – Market Center Official Close | N – Next Day | O – Opening Prints  | P – Prior Reference Price | Q – Market Center Official Open | R – Seller | S – Split Trade | T – Form T | U – Extended Trading Hours (Sold Out of Sequence)  | V – Contingent Trade | W – Average Price Trade | X – Cross/Periodic Auction Trade | Y – Yellow Flag Regular Trade | Z – Sold (Out of Sequence)  | 1 – Stopped Stock (Regular Trade) | 4 – Derivatively Priced | 5 – Re-Opening Prints | 6 – Closing Prints | 7 – Qualified Contingent Trade (QCT)  | 8 – Placeholder for 611 Exempt | 9 – Corrected Consolidated Close (Per Listing Market)   # noqa: E501

        :param sales_conditions: The sales_conditions of this RealtimeStockPrice.  # noqa: E501
        :type: str
        """

        self._sales_conditions = sales_conditions

    @property
    def quote_conditions(self):
        """Gets the quote_conditions of this RealtimeStockPrice.  # noqa: E501

        When applicable, indicates any quote condition modifiers associated with the trade. Quote Condition Modifiers include: R – Regular | A – Slow on Ask | – Slow on Bid | C – Closing | D – News Dissemination | F – Slow on ASK (LRP or Gap Quote)  | E – Slow on Bid (LRP or Gap Quote) | G – Trading Range Indication | H – Slow on Bid and Ask | I – Order Imbalance  |  J – Due to Related - News Dissemination | K – Due to Related - News Pending | O – Open | L – Closed  | M – Volatility Trading Pause | N – Non-Firm Quote | O – Opening | P – News Pending | S – Due to Related  | T – Resume | U – Slow on Bid and Ask (LRP or Gap Quote) | V – In View of Common | W – Slow on Bid and Ask (LRP or Gap Quote)  | X – Equipment Changeover | Y – Sub-Penny Trading | Z – No Open / No Resume | F – Fast Trading | U – Slow on Bid and Ask (Non-Firm)  | One-Sided – One-Sided | X – Order Influx | 0 – Special Opening Quote | Halted – Halted | Benchmark – Benchmark | Implied – Implied  | Exchange Best – Exchange Best | 1 – Market Wide Circuit Breaker Level 1 | 2 – Market Wide Circuit Breaker Level 2  | 3 – Market Wide Circuit Breaker Level 3 | Rotation – Rotation | Auto Exec Eligible – Auto Exec Eligible | Bid Side Firm – Bid Side Firm  | Ask Side Firm – Ask Side Firm | 4 – On Demand Intraday Auction | I – Indicative Value (OPRA) | 45 – Additional Information Required (CTS)  | 46 – Regulatory Concern (CTS) | 47 – Merger Effective | 49 – Corporate Action (CTS) | 50 – New Security Offering (CTS)  | 51 – Intraday Indicative Value Unavailable (CTS)   # noqa: E501

        :return: The quote_conditions of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """
        return self._quote_conditions
        
    @property
    def quote_conditions_dict(self):
        """Gets the quote_conditions of this RealtimeStockPrice.  # noqa: E501

        When applicable, indicates any quote condition modifiers associated with the trade. Quote Condition Modifiers include: R – Regular | A – Slow on Ask | – Slow on Bid | C – Closing | D – News Dissemination | F – Slow on ASK (LRP or Gap Quote)  | E – Slow on Bid (LRP or Gap Quote) | G – Trading Range Indication | H – Slow on Bid and Ask | I – Order Imbalance  |  J – Due to Related - News Dissemination | K – Due to Related - News Pending | O – Open | L – Closed  | M – Volatility Trading Pause | N – Non-Firm Quote | O – Opening | P – News Pending | S – Due to Related  | T – Resume | U – Slow on Bid and Ask (LRP or Gap Quote) | V – In View of Common | W – Slow on Bid and Ask (LRP or Gap Quote)  | X – Equipment Changeover | Y – Sub-Penny Trading | Z – No Open / No Resume | F – Fast Trading | U – Slow on Bid and Ask (Non-Firm)  | One-Sided – One-Sided | X – Order Influx | 0 – Special Opening Quote | Halted – Halted | Benchmark – Benchmark | Implied – Implied  | Exchange Best – Exchange Best | 1 – Market Wide Circuit Breaker Level 1 | 2 – Market Wide Circuit Breaker Level 2  | 3 – Market Wide Circuit Breaker Level 3 | Rotation – Rotation | Auto Exec Eligible – Auto Exec Eligible | Bid Side Firm – Bid Side Firm  | Ask Side Firm – Ask Side Firm | 4 – On Demand Intraday Auction | I – Indicative Value (OPRA) | 45 – Additional Information Required (CTS)  | 46 – Regulatory Concern (CTS) | 47 – Merger Effective | 49 – Corporate Action (CTS) | 50 – New Security Offering (CTS)  | 51 – Intraday Indicative Value Unavailable (CTS)  as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The quote_conditions of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.quote_conditions
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'quote_conditions': value }

        
        return result
        

    @quote_conditions.setter
    def quote_conditions(self, quote_conditions):
        """Sets the quote_conditions of this RealtimeStockPrice.

        When applicable, indicates any quote condition modifiers associated with the trade. Quote Condition Modifiers include: R – Regular | A – Slow on Ask | – Slow on Bid | C – Closing | D – News Dissemination | F – Slow on ASK (LRP or Gap Quote)  | E – Slow on Bid (LRP or Gap Quote) | G – Trading Range Indication | H – Slow on Bid and Ask | I – Order Imbalance  |  J – Due to Related - News Dissemination | K – Due to Related - News Pending | O – Open | L – Closed  | M – Volatility Trading Pause | N – Non-Firm Quote | O – Opening | P – News Pending | S – Due to Related  | T – Resume | U – Slow on Bid and Ask (LRP or Gap Quote) | V – In View of Common | W – Slow on Bid and Ask (LRP or Gap Quote)  | X – Equipment Changeover | Y – Sub-Penny Trading | Z – No Open / No Resume | F – Fast Trading | U – Slow on Bid and Ask (Non-Firm)  | One-Sided – One-Sided | X – Order Influx | 0 – Special Opening Quote | Halted – Halted | Benchmark – Benchmark | Implied – Implied  | Exchange Best – Exchange Best | 1 – Market Wide Circuit Breaker Level 1 | 2 – Market Wide Circuit Breaker Level 2  | 3 – Market Wide Circuit Breaker Level 3 | Rotation – Rotation | Auto Exec Eligible – Auto Exec Eligible | Bid Side Firm – Bid Side Firm  | Ask Side Firm – Ask Side Firm | 4 – On Demand Intraday Auction | I – Indicative Value (OPRA) | 45 – Additional Information Required (CTS)  | 46 – Regulatory Concern (CTS) | 47 – Merger Effective | 49 – Corporate Action (CTS) | 50 – New Security Offering (CTS)  | 51 – Intraday Indicative Value Unavailable (CTS)   # noqa: E501

        :param quote_conditions: The quote_conditions of this RealtimeStockPrice.  # noqa: E501
        :type: str
        """

        self._quote_conditions = quote_conditions

    @property
    def market_center_code(self):
        """Gets the market_center_code of this RealtimeStockPrice.  # noqa: E501

        The market center character code.  # noqa: E501

        :return: The market_center_code of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """
        return self._market_center_code
        
    @property
    def market_center_code_dict(self):
        """Gets the market_center_code of this RealtimeStockPrice.  # noqa: E501

        The market center character code. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The market_center_code of this RealtimeStockPrice.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.market_center_code
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'market_center_code': value }

        
        return result
        

    @market_center_code.setter
    def market_center_code(self, market_center_code):
        """Sets the market_center_code of this RealtimeStockPrice.

        The market center character code.  # noqa: E501

        :param market_center_code: The market_center_code of this RealtimeStockPrice.  # noqa: E501
        :type: str
        """

        self._market_center_code = market_center_code

    @property
    def is_darkpool(self):
        """Gets the is_darkpool of this RealtimeStockPrice.  # noqa: E501

        Whether or not the current trade is from a darkpool or not.  # noqa: E501

        :return: The is_darkpool of this RealtimeStockPrice.  # noqa: E501
        :rtype: bool
        """
        return self._is_darkpool
        
    @property
    def is_darkpool_dict(self):
        """Gets the is_darkpool of this RealtimeStockPrice.  # noqa: E501

        Whether or not the current trade is from a darkpool or not. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The is_darkpool of this RealtimeStockPrice.  # noqa: E501
        :rtype: bool
        """

        result = None

        value = self.is_darkpool
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'is_darkpool': value }

        
        return result
        

    @is_darkpool.setter
    def is_darkpool(self, is_darkpool):
        """Sets the is_darkpool of this RealtimeStockPrice.

        Whether or not the current trade is from a darkpool or not.  # noqa: E501

        :param is_darkpool: The is_darkpool of this RealtimeStockPrice.  # noqa: E501
        :type: bool
        """

        self._is_darkpool = is_darkpool

    @property
    def security(self):
        """Gets the security of this RealtimeStockPrice.  # noqa: E501


        :return: The security of this RealtimeStockPrice.  # noqa: E501
        :rtype: RealtimeStockPriceSecurity
        """
        return self._security
        
    @property
    def security_dict(self):
        """Gets the security of this RealtimeStockPrice.  # noqa: E501


        :return: The security of this RealtimeStockPrice.  # noqa: E501
        :rtype: RealtimeStockPriceSecurity
        """

        result = None

        value = self.security
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'security': value }

        
        return result
        

    @security.setter
    def security(self, security):
        """Sets the security of this RealtimeStockPrice.


        :param security: The security of this RealtimeStockPrice.  # noqa: E501
        :type: RealtimeStockPriceSecurity
        """

        self._security = security

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RealtimeStockPrice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
